#
# Author:  Nathan Hamiel
#
# Copyright (c) 2011 RAFT Team
#
# This file is part of RAFT.
#
# RAFT is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# RAFT is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with RAFT.  If not, see <http://www.gnu.org/licenses/>.
#
# This is the analysis for the identification of errors in the response data.

# ToDo: Do something with this list of common error strings, this should probably be used
# for highlighting the error condition in the source interface

import cgi

# List of common error strings:
ERRORS = """A syntax error has occurred
ADODB.Field error
ASP.NET is configured to show verbose error messages
ASP.NET_SessionId
Active Server Pages error
An illegal character has been found in the statement
An unexpected token "END-OF-STATEMENT" was found
CLI Driver
Can't connect to local
Custom Error Message
DB2 Driver
DB2 Error
DB2 ODBC
Died at
Disallowed Parent Path
Error Diagnostic Information
Error Message : Error loading required libraries.
Error Report
Error converting data type varchar to numeric
Fatal error
Incorrect syntax near
Index of
Internal Server Error
Invalid Path Character
Invalid procedure call or argument
Invision Power Board Database Error
JDBC Driver
JDBC Error
JDBC MySQL
JDBC Oracle
JDBC SQL
Microsoft OLE DB Provider for ODBC Drivers
Microsoft VBScript compilation error
Microsoft VBScript error
MySQL Driver
MySQL Error
MySQL ODBC
ODBC DB2
ODBC Driver
ODBC Error
ODBC Microsoft Access
ODBC Oracle
ODBC SQL
ODBC SQL Server
OLE/DB provider returned message
ORA-0
ORA-1
Oracle DB2
Oracle Driver
Oracle Error
Oracle ODBC
PHP Error
PHP Parse error
PHP Warning
Parent Directory
Permission denied: 'GetObject'
PostgreSQL query failed: ERROR: parser: parse error
SQL Server Driver][SQL Server
SQL command not properly ended
SQLException
Supplied argument is not a valid PostgreSQL result
Syntax error in query expression
The error occurred in
The script whose uid is
Type mismatch
Unable to jump to row
Unclosed quotation mark before the character string
Unterminated string constant
Warning: Cannot modify header information - headers already sent
Warning: Supplied argument is not a valid File-Handle resource in
Warning: mysql_query()
Warning: pg_connect(): Unable to connect to PostgreSQL server: FATAL
You have an error in your SQL syntax near
data source=
detected an internal error [IBM][CLI Driver][DB2/6000]
error
include_path
invalid query
is not allowed to access
missing expression
mySQL error with query
mysql error
on MySQL result index
on line
server at
server object error
supplied argument is not a valid MySQL result resource
unexpected end of SQL command"""

def find_errors(content):
    """ Find error conditions in the response data of requests """
    
    format = "<h2>Errors</h2>\n"
    errorList = []
    
    for item in ERRORS.splitlines():
        for line in content.splitlines():
            if item.rstrip() in line:
                #errorList.append(line)
                format += cgi.escape(line)
    # return(errorList)
    return(format)
    
