#
# Author: Gregory Fleischer (gfleischer@gmail.com)
#
# Copyright (c) 2011 RAFT Team
#
# This file is part of RAFT.
#
# RAFT is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# RAFT is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with RAFT.  If not, see <http://www.gnu.org/licenses/>.
#

from PyQt4 import QtWebKit

class customWebPage(QtWebKit.QWebPage):
    def __init__(self, parent, userAgentForUrl = None, userDialogCallback = None):
        self.__userAgentForUrl = userAgentForUrl
        self.__userDialogCallback = userDialogCallback
        QtWebKit.QWebPage.__init__(self, parent)

    def userAgentForUrl(self, url):
        if self.__userAgentForUrl:
            return self.__userAgentForUrl
        return QtWebKit.QWebPage.userAgentForUrl(self, url)

    def javaScriptAlert(self, frame, msg):
        if self.__userDialogCallback:
            # TODO: implement
            pass ### print('alert from [%s / %s]: %s' % (frame.url(), frame.requestedUrl(), msg))
        else:
            QtWebKit.QWebPage.javaScriptAlert(self, frame, msg)

    def javaScriptConfirm(self, frame, msg):
        if self.__userDialogCallback:
            # TODO: implement
            pass ### print('confirm from [%s / %s]: %s' % (frame.url(), frame.requestedUrl(), msg))
            return True
        else:
            return QtWebKit.QWebPage.javaScriptConfirm(self, frame, msg)

    def javaScriptPrompt(self, frame, msg, defaultValue, result):
        if self.__userDialogCallback:
            # TODO: implement
            pass ### print('prompt from [%s / %s]: %s' % (frame.url(), frame.requestedUrl(), msg))
            result = defaultValue
            return True
        else:
            return QtWebKit.QWebPage.javaScriptPrompt(self, frame, msg, defaultValue, result)

    def javaScriptConsoleMessage(self, message, lineNumber, sourceID):
        if self.__userDialogCallback:
            # TODO: implement
            pass ### print('console log from [%s / %s]: %s' % (lineNumber, sourceID, message))
        else:
            return QtWebKit.QWebPage.javaScriptConsoleMessage(self, message, lineNumber, sourceID)